﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.Diagnostics;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.DataPresenter.Events;
using Infragistics.Windows.Selection;

namespace WpfApplication8
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        private readonly List<Thing> stuff;

        public Window1()
        {
            InitializeComponent();

            stuff = new List<Thing>();

            for( int i = 0; i < 10; i++ )
            {
                stuff.Add( new Thing { Id = i, Happy = i.ToString(), This = "A" + i, That = "B" + i } );
            }

            bob.DataSource = stuff;

            ContextMenu menu = new ContextMenu();

            menu.Items.Add( new MenuItem {Header = "Hello"} );
            menu.Items.Add( new MenuItem {Header = "How are You?" } );

            bob.ContextMenu = menu;

            bob.SelectedIds.CollectionChanged += onSelectionChanged;

        }

        private void onSelectionChanged( object sender, NotifyCollectionChangedEventArgs e )
        {
            Trace.WriteLine( bob.SelectedIds.Count );

        }
    }


    public class MyGrid : XamDataGrid
    {
        static MyGrid()
        {
            EventManager.RegisterClassHandler( typeof( DataRecordPresenter ), PreviewMouseRightButtonDownEvent,
                                               new MouseButtonEventHandler( onMouseRightButtonDown ) );
        }
        public MyGrid()
        {
            FieldSettings.AllowEdit = false;

            SelectedItemsChanged += onSelectedItemsChanged;
        }

        public readonly ObservableCollection<int> SelectedIds = new ObservableCollection<int>();
        
        private void onSelectedItemsChanged( object sender, SelectedItemsChangedEventArgs e )
        {
            SelectedItemHolder holder = SelectedItems;

            SelectedIds.Clear();

            foreach ( ISelectableItem item in holder )
            {
                Thing bw;
                if( item is Cell )
                {
                    Cell c = (Cell)item;

                    bw = (Thing)c.Record.DataItem;
                }
                else if( item is DataRecord )
                {
                    DataRecord dr = (DataRecord)item;

                    bw = (Thing)dr.DataItem;
                }
                else bw = null;

                if( bw != null && ! SelectedIds.Contains( bw.Id ) ) SelectedIds.Add( bw.Id );
            }
        }

        private static void onMouseRightButtonDown(object sender, MouseButtonEventArgs e )
        {
            DataRecordPresenter drp = sender as DataRecordPresenter;

            if ( drp != null )
            { 
                drp.Record.DataPresenter.SelectedItems.Records.Add( drp.Record );
                drp.Record.IsSelected = true;
            }
        }
    }

    public class Thing
    {
        public int    Id { get; set; }
        public string Happy { get; set;} 
        public string This { get; set; }
        public string That { get; set; }
    }
}
